Type: Package
Package: gDR
Title: Umbrella package for R packages in the gDR suite
Version: 1.9.1
Date: 2025-10-30
Authors@R: c(
    person("Allison", "Vuong", , "vuong.allison@gene.com", role = "aut"),
    person("Bartosz", "Czech", role = "aut",
           comment = c(ORCID = "0000-0002-9908-3007")),
    person("Arkadiusz", "Gladki", role=c("cre", "aut"), email="gladki.arkadiusz@gmail.com",
           comment = c(ORCID = "0000-0002-7059-6378")),
    person("Marc", "Hafner", role = "aut",
           comment = c(ORCID = "0000-0003-1337-7598")),
    person("Dariusz", "Scigocki", role = "aut"),
    person("Janina", "Smola", role = "aut"),
    person("Sergiu", "Mocanu", role = "aut")
  )
Description: Package is a part of the gDR suite. It reexports functions from other packages
    in the gDR suite that contain critical processing functions and utilities.
    The vignette walks through the full processing pipeline for drug response analyses that
    the gDR suite offers.
License: Artistic-2.0
Depends: R (>= 4.2), gDRcore (>= 1.7.1), gDRimport (>= 1.7.1), gDRutils
        (>= 1.7.1)
Suggests: BiocStyle, BumpyMatrix, futile.logger, gDRstyle (>= 1.7.1),
        gDRtestData (>= 1.7.1), kableExtra, knitr, markdown, purrr,
        rmarkdown, SummarizedExperiment, testthat, yaml
URL: https://github.com/gdrplatform/gDR,
        https://gdrplatform.github.io/gDR/
BugReports: https://github.com/gdrplatform/gDR/issues
biocViews: Software, DataImport, ShinyApps
VignetteBuilder: knitr
ByteCompile: TRUE
LazyLoad: yes
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.1
SwitchrLibrary: gDR
DeploySubPath: gDR
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/gDR
git_branch: devel
git_last_commit: 9871bb8
git_last_commit_date: 2025-10-30
Repository: Bioconductor 3.23
Date/Publication: 2025-10-31
NeedsCompilation: no
Packaged: 2025-10-31 21:54:15 UTC; biocbuild
Author: Allison Vuong [aut],
  Bartosz Czech [aut] (ORCID: <https://orcid.org/0000-0002-9908-3007>),
  Arkadiusz Gladki [cre, aut] (ORCID:
    <https://orcid.org/0000-0002-7059-6378>),
  Marc Hafner [aut] (ORCID: <https://orcid.org/0000-0003-1337-7598>),
  Dariusz Scigocki [aut],
  Janina Smola [aut],
  Sergiu Mocanu [aut]
Maintainer: Arkadiusz Gladki <gladki.arkadiusz@gmail.com>

# gDR overview
gDR is an umbrella package for the gDR programmatic R interface.

The gDR suite offers a full stack solution for processing drug response data. This enables a range of users across computational savvy, (i.e. lab scientists and computational scientists alike) to access the same, standardized data. The suite is made up of several core R packages.

![Figure 1. The overview of R packages that are available via gDR umbrella package.  ](https://raw.githubusercontent.com/gdrplatform/gDR/main/inst/images/overview.png)  

# Installation

The easiest way to use functions from gDR package is by using the Bioconductor.

1. Install BiocManager

```
install.packages("BiocManager")
```

2. Install gDR packages

```
BiocManager::install(c("gDRstyle", "gDRtestData", "gDR"), version = "devel")
```

You've just successfully set up the environment for the gDR umbrella package. Please see [gDR vignette](https://gdrplatform.github.io/gDR/articles/gDR.html) for examples of usage.


# How to contribute
We are eager to make this tool useful for the community. We welcome any suggestions via GitHub issues, or pull requests for bugfixes/new features. When making pull requests, please first have a look at the style conventions in [gDRstyle](https://gdrplatform.github.io/gDRstyle/style_guide.html).

#' Import raw data
#'
#' @param manifest_file character, file path(s) to manifest(s)
#' @param template_file character, with datapaths and names of results file(s)
#' or character with file path of templates file(s)
#' @param results_file character, with datapaths and names of results file(s)
#' or character with file path of results file(s)
#' @param instrument string with type of instrument used
#' 
#' @examples
#' td <- get_test_data()
#' i_df <- import_data(manifest_path(td), template_path(td), result_path(td))
#' 
#' @return a \code{data.table}
#'
#' @keywords import
#' @export
#'
import_data <- function(manifest_file,
                        template_file,
                        results_file,
                        instrument = "EnVision") {
  loaded_data <- load_data(manifest_file = manifest_file,
                           df_template_files = template_file,
                           results_file = results_file,
                           instrument = instrument)
  merge_data(manifest = loaded_data$manifest,
             treatments = loaded_data$treatments,
             data = loaded_data$data)
}

context("utils")

test_that("import_data", {
  
  # Define path for data stored in gDR package
  dataDir <- system.file("extdata", "data1", package = "gDRimport")
  
  # Extract path for example raw_data
  manifest <- list.files(dataDir, pattern = "manifest", full.names = TRUE)
  template <- list.files(dataDir, pattern = "Template", full.names = TRUE)
  raw_data <- list.files(dataDir, pattern = "^RawData", full.names = TRUE)
  suppressWarnings(
    checkmate::expect_data_table(import_data(manifest, template, raw_data))
  )
})

# fix for the NOTE in R CMD CHECK
# (packages defined in  Depends must have records in NAMESPACE)
#' @importFrom gDRimport load_data
#' @importFrom gDRcore merge_data
#' @importFrom gDRutils fit_curves

#' @keywords internal
#' @return package help page
"_PACKAGE"
NULL

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----echo=TRUE, results='asis'------------------------------------------------
library(gDR)
# get test data from gDRimport package
# i.e. paths to manifest, templates and results files
td <- get_test_data()
manifest_path(td)
template_path(td)
result_path(td)

## ----echo=TRUE, results='asis', warning=FALSE, results='hide', message=FALSE----
# Import data
imported_data <- 
  import_data(manifest_path(td), template_path(td), result_path(td))
head(imported_data)

## -----------------------------------------------------------------------------
inl <- prepare_input(imported_data)
detected_data_types <- names(inl$exps)
detected_data_types
se <- create_and_normalize_SE(
  inl$df_list[["single-agent"]],
  data_type = "single-agent",
  nested_confounders = inl$nested_confounders)
se

## ----echo=TRUE, results='asis', warning=FALSE, results='hide', message=FALSE----
se <- average_SE(se, data_type = "single-agent")
se <- fit_SE(se, data_type = "single-agent")

## ----echo=TRUE----------------------------------------------------------------
se

## ----echo=TRUE, results='asis', warning=FALSE, results='hide', message=FALSE----
# Run gDR pipeline
mae <- runDrugResponseProcessingPipeline(imported_data)

## ----echo=TRUE----------------------------------------------------------------
mae

## ----echo=TRUE----------------------------------------------------------------
names(mae)
SummarizedExperiment::assayNames(mae[[1]])

## ----echo=TRUE----------------------------------------------------------------
library(kableExtra)
se <- mae[["single-agent"]]
head(convert_se_assay_to_dt(se, "Metrics"))

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

#' Small data.table with raw data used for processing via gDR
#'
#' A dataset containing the ReadoutValues for single-agent experiments 
#' made-up of 10 drugs and 10 cell lines
#'
#' @format A data frame with 3300 rows and 12 variables:
#' \describe{
#'   \item{Barcode}{barcode}
#'   \item{clid}{cell line id}
#'   \item{CellLineName}{cell line name}
#'   \item{Tissue}{cell line tissue}
#'   \item{ReferenceDivisionTime}{cell line division time}
#'   \item{Gnumber}{drug id}
#'   \item{DrugName}{drug name}
#'   \item{drug_moa}{drug mode of action}
#'   \item{Concentration}{drug concentration}
#'   \item{ReadoutValue}{readout value}
#'   \item{BackgroundValue}{backgroud value}
#'   \item{Duration}{duration}
#' }
#' 
#' @usage data(small_data)
#' 
#' @keywords data
#' @return data.table
"small_data"

#' Small data.table with raw combo data used for processing via gDR
#'
#' A dataset containing the ReadoutValues for combo experiments made-up of 
#' 3 drugs, 2 co-drugs, and 2 cell lines
#'
#' @format A data frame with 3600 rows and 16 variables:
#' \describe{
#'   \item{Barcode}{barcode}
#'   \item{clid}{cell line id}
#'   \item{CellLineName}{cell line name}
#'   \item{Tissue}{cell line tissue}
#'   \item{ReferenceDivisionTime}{cell line division time}
#'   \item{Gnumber}{drug id}
#'   \item{DrugName}{drug name}
#'   \item{drug_moa}{drug mode of action}
#'   \item{Concentration}{drug concentration}
#'   \item{Gnumber_2}{co-drug id}
#'   \item{DrugName_2}{co-drug name}
#'   \item{drug_moa_2}{co-drug mode of action}
#'   \item{Concentration_2}{co-drug concentration}
#'   \item{ReadoutValue}{readout value}
#'   \item{BackgroundValue}{backgroud value}
#'   \item{Duration}{duration}
#' }
#' 
#' @usage data(small_combo_data)
#' 
#' @keywords data
#' @return data.table
"small_combo_data"

# sudo apt-get install plantuml
# pretty old version
#jar_path="/usr/share/platinuml/platinuml.jar"
jar_path="./plantuml-1.2023.13.jar"
if [ -f $jar_path ]; then
   echo "File $jar_path exists."
else
   wget https://github.com/plantuml/plantuml/releases/download/v1.2023.13/plantuml-1.2023.13.jar
fi
java -Djava.awt.headless=true -jar $jar_path *.puml -tpng -o ../images/

---
title: "gDR suite"
author: "gDR team"
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Running the drug response processing pipeline}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Introduction {#intro}

Over decades, many departments across gRED and Roche have generated large amounts of drug response screening data using Genentech's rich drug compounds inventory. While extensive labor and time has been invested to generate these data, they are not analyzed in a standardized manner for meaningful comparison. On one hand, large screens are performed across many cell lines and drugs in a semi-automated manner. On the other hand, small-scale studies, which focused on factors that contribute to sensitivity and resistance to certain therapies, are generally performed by each individual scientist with limited automation. These are complementary approaches but were rarely handled the same way. Commercial softwares are available for analyzing large datasets, whereas researchers for small-scale datasets often process data ad hoc through software like PRISM.

Here, we propose a suite of computational tools that enable the processing, archiving, and visualization of drug response data from any experiment, regardless of size or experimental design, thus ensuring reproducibility and implementation of the Findable, Accessible, Interoperable, and Reusable (F.A.I.R.) principles, with the goal of making this accessible to the public community.

For now we share a subset of the gDR suite components for pre-processing and processing the data.

## R Packages {#rpackages}

gDR suite consists of a few packages that power our app and make it a comprehensive tool.
All the packages under the gDR umbrella are stored in the [gDR platform GitHub organization](https://github.roche.com/gdrplatform/).

We are happy to share with you our packages for importing, processing and managing gDR data:
- gDRimport
- gDRcore
- gDRutils
- gDRtestData

## Data structures 
The gDR data model is based on the SummarizedExperiment and BumpyMatrix. If readers are unfamiliar with these data models, we recommend first reading [SummarizedExperiment vignettes](https://bioconductor.org/packages/release/bioc/vignettes/SummarizedExperiment/inst/doc/SummarizedExperiment.html), followed by the [BumpyMatrix vignettes](https://www.bioconductor.org/packages/devel/bioc/vignettes/BumpyMatrix/inst/doc/BumpyMatrix.html). The SummarizedExperiment data structure enables ease of subsetting within the SummarizedExperiment object, but also provides ease when trying to correlate drug response data with genomic data, as these data may jointly stored in a MultiAssayExperiment. The BumpyMatrix allows for storage of multi-dimensional data while retaining a matrix abstraction.

This data structure is the core data structure that all downstream processing functions as well as visualization tools operate off of.

## Overview
The gDR suite was designed in a modular manner, such that a user can jump into the "standard" end-to-end gDR processing pipeline at several entry points as is suitable for his or her needs. The full pipeline involves:

```              
      manifest, template(s), raw data
                        |
                        |  1. Aggregating all raw data and metadata
                        |  into a single long table. 
                        |
                        V
              single, long table
                        |
                        |  2. Transforming the long table into 
                        |  a SummarizedExperiment object with BumpyMatrix assays 
                        |  by specifying what columns belong on rows, 
                        |  columns, and nested.
                        |
                        V
          SummarizedExperiment object
          with raw and treated assays
                        |
                        |  3. Normalizing, averaging, and fitting data.
                        |
                        V
          SummarizedExperiment object
          with raw, treated, normalized,
           averaged, and metric assays, 
   ready for use by downstream visualization
              
 ```
 
A user should be able to enter any part of this pipeline as long as they are able to create the intermediate object
(i.e., the individual manifest, template, and raw data files, or a single, long table, or a SummarizedExperiment object with Bumpy assays).

# Quick start

## Aggregating raw data and metadata (1)

The gDR suite ultimately requires a single, long merged table containing both raw data and metadata.

To support a common use case, we provide a convenience function that takes three objects: manifest, template(s), and raw data to create this single, long merged table for the user. The manifest contains metadata on the experimental design, template files specify the drugs and cell lines used, and the raw data output files obtained from a plate reader or a scanner.

Exemplary data can be found here:

```{r, echo=TRUE, results='asis'}
library(gDR)
# get test data from gDRimport package
# i.e. paths to manifest, templates and results files
td <- get_test_data()
manifest_path(td)
template_path(td)
result_path(td)
```

Using the convenience function `import_data`, the long table is easily created: 

```{r, echo=TRUE, results='asis', warning=FALSE, results='hide', message=FALSE} 
# Import data
imported_data <- 
  import_data(manifest_path(td), template_path(td), result_path(td))
head(imported_data)
```

This function will expect certain "identifiers" that tell the processing functions which columns in the long table map to certain expected fields, so that each column is interpreted correctly. For more details regarding these identifiers, see the "Details" section of `?identifiers`. Use `set_env_identifier` or `set_SE_identifiers` to set up the correct mappings between the expected fields and your long table column names.

## Transforming data into a SummarizedExperiment (2)
Next, we can transform the long table into our initial SummarizedExperiment object.
To do so, we need to tell the software:
- What should go on rows and columns versus be nested in the assay.
- Which rows in our table to consider as "control" versus "treated" for normalization.
- Which data type should be converted into SE.

We can do so by setting the `untreated_tag` identifier like `set_env_identifier("untreated_tag" = c("MY_CONTROL_TERMINOLOGY_HERE"))`.
specifying the `nested_keys` argument within `create_and_normalize_SE` and specifiying `data_type`.

```{r}
inl <- prepare_input(imported_data)
detected_data_types <- names(inl$exps)
detected_data_types
se <- create_and_normalize_SE(
  inl$df_list[["single-agent"]],
  data_type = "single-agent",
  nested_confounders = inl$nested_confounders)
se
```
Note that this has created a SummarizedExperiment object with `rowData`, `colData`, `metadata` and 3 `assays`.


## Averaging and fitting data (3)
Next, we can average and fit the data of interest. 
```{r, echo=TRUE, results='asis', warning=FALSE, results='hide', message=FALSE}
se <- average_SE(se, data_type = "single-agent")
se <- fit_SE(se, data_type = "single-agent")
```
```{r, echo=TRUE}
se
```

## runDrugResponseProcessingPipeline
Steps (2) and (3) can be combined into a single step through a convenience function: `runDrugResponseProcessingPipeline`.  Moreover, the output is `MultiAssayExperiment` object with one experiment per each detected data type. Currently four data types are supported: 'single-agent', 'cotreatment', 'codilution' and 'matrix'. The first three data types are processed via the 'single-agent' model while the 'marix' data is processed via the 'combintation' model. 

```{r, echo=TRUE, results='asis', warning=FALSE, results='hide', message=FALSE}
# Run gDR pipeline
mae <- runDrugResponseProcessingPipeline(imported_data)
```
```{r, echo=TRUE}
mae
```

Note that our final MultiAssayExperiment object can be made up of multiple experiments with multiple assays:

```{r, echo=TRUE}
names(mae)
SummarizedExperiment::assayNames(mae[[1]])
```

Each assay from each experiment can be easily transformed to `data.table` format using `convert_se_assay_to_dt` function:

```{r, echo=TRUE}
library(kableExtra)
se <- mae[["single-agent"]]
head(convert_se_assay_to_dt(se, "Metrics"))
```

# Appendix
Once the data is stored in the database, there are multiple ways to visualize the data depending on the scientific needs. The primary method to do is through our RShiny visualization tool 'gDRviz'. Here, users can search and select experiments present in the database, and use downstream visualization modules to look at dose response curves, heatmaps, etc.

# SessionInfo {-}

```{r sessionInfo}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{small_data}
\alias{small_data}
\title{Small data.table with raw data used for processing via gDR}
\format{
A data frame with 3300 rows and 12 variables:
\describe{
\item{Barcode}{barcode}
\item{clid}{cell line id}
\item{CellLineName}{cell line name}
\item{Tissue}{cell line tissue}
\item{ReferenceDivisionTime}{cell line division time}
\item{Gnumber}{drug id}
\item{DrugName}{drug name}
\item{drug_moa}{drug mode of action}
\item{Concentration}{drug concentration}
\item{ReadoutValue}{readout value}
\item{BackgroundValue}{backgroud value}
\item{Duration}{duration}
}
}
\usage{
data(small_data)
}
\value{
data.table
}
\description{
A dataset containing the ReadoutValues for single-agent experiments
made-up of 10 drugs and 10 cell lines
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/import_data.R
\name{import_data}
\alias{import_data}
\title{Import raw data}
\usage{
import_data(
  manifest_file,
  template_file,
  results_file,
  instrument = "EnVision"
)
}
\arguments{
\item{manifest_file}{character, file path(s) to manifest(s)}

\item{template_file}{character, with datapaths and names of results file(s)
or character with file path of templates file(s)}

\item{results_file}{character, with datapaths and names of results file(s)
or character with file path of results file(s)}

\item{instrument}{string with type of instrument used}
}
\value{
a \code{data.table}
}
\description{
Import raw data
}
\examples{
td <- get_test_data()
i_df <- import_data(manifest_path(td), template_path(td), result_path(td))

}
\keyword{import}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gDR-package.R, R/package.R
\docType{package}
\name{gDR-package}
\alias{gDR-package}
\title{gDR: Umbrella package for R packages in the gDR suite}
\value{
package help page

package help page
}
\description{
Package is a part of the gDR suite. It reexports functions from other packages in the gDR suite that contain critical processing functions and utilities. The vignette walks through the full processing pipeline for drug response analyses that the gDR suite offers.

Package is a part of the gDR suite. It reexports functions from other packages in the gDR suite that contain critical processing functions and utilities. The vignette walks through the full processing pipeline for drug response analyses that the gDR suite offers.
}
\note{
To learn more about functions start with \code{help(package = "gDR")}
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/gdrplatform/gDR}
  \item \url{https://gdrplatform.github.io/gDR/}
  \item Report bugs at \url{https://github.com/gdrplatform/gDR/issues}
}


Useful links:
\itemize{
  \item \url{https://github.com/gdrplatform/gDR}
  \item \url{https://gdrplatform.github.io/gDR/}
  \item Report bugs at \url{https://github.com/gdrplatform/gDR/issues}
}

}
\author{
\strong{Maintainer}: Arkadiusz Gladki \email{gladki.arkadiusz@gmail.com} (\href{https://orcid.org/0000-0002-7059-6378}{ORCID})

Authors:
\itemize{
  \item Allison Vuong \email{vuong.allison@gene.com}
  \item Bartosz Czech (\href{https://orcid.org/0000-0002-9908-3007}{ORCID})
  \item Marc Hafner (\href{https://orcid.org/0000-0003-1337-7598}{ORCID})
  \item Dariusz Scigocki
  \item Janina Smola
  \item Sergiu Mocanu
}

}
\keyword{internal}
